{% extends 'base.html.twig' %}

{% block body %}
    <div class="row justify-content-center mt-5">
        <div class="col-xs-10 col-lg-10 border-bottom">
            <h2>{{ subscription.name }}</h2>
        </div>
        <div class="col-xs-10 col-md-8 col-lg-5 border-right mt-5">
            {{ form(subscriptionForm) }}
        </div>
        <div class="col-xs-10 col-md-8 col-lg-5 mt-5">
            <h3 class="text-center">Zahlungen <button type="button" id="show-add-modal-btn" data-toggle="modal" data-target="#payment-modal" class="btn btn-outline-success btn-sm">+</button></h3>
            <div id="payments-list" style="max-height: 75%; overflow: scroll;">
                {% include 'payment/list.html.twig' with {'payments': subscription.payments} %}
            </div>
        </div>
    </div>
{% endblock %}

{% block modal %}
    <div class="modal fade" id="payment-modal" tabindex="-1" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Zahlung hinzufügen</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body add-payment-form">
                    {{ form(paymentForm) }}
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Schließen</button>
                    <button type="button" id="modal-save-btn" class="btn btn-primary">Speichern</button>
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="delete-payment-modal" tabindex="-1" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Zahlung löschen?</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body add-payment-form">
                    Soll diese Zahlung wirklich gelöscht werden?
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Schließen</button>
                    <button type="button" id="modal-delete-payment-btn" data-payment-id="" class="btn btn-danger">Löschen</button>
                </div>
            </div>
        </div>
    </div>

{% endblock %}

{% block javascripts %}
    {{ parent() }}
    <script>
        let paymentListSelector = '#payments-list';

        $('#payment-modal').modal({
            show: false,
        });

        $('#delete-payment-modal').modal({
            show: false,
        });

        $('#modal-save-btn').on('click', function(){
            $('#payment-modal').modal('hide');
            $('#add-payment-form').submit();
        });

        $('#add-payment-form').on('submit', function (event){
            event.preventDefault();
            $(paymentListSelector).fadeOut();
            let formData = $(this).serialize();
            let url = "{{ path('add_payment', {'id': subscription.id}) }}";
            $.ajax({
                url: url,
                method: 'POST',
                data: formData
            }).done(function(response) {
                $(paymentListSelector).fadeIn();
                $(paymentListSelector).html(response);
            });
        });

        $(document).on('mouseover click', '.list-group-item', function(event) {
            $.each($('.list-group-item'), function(i, val) {
                $(val).children('.menu').hide();
            });

            $(this).children('.menu').show();
        });

        $(document).on('mouseleave', '.list-group-item', function(event) {
            $(this).children('.menu').hide();
        });

        $(document).on('click', '.delete-payment-btn', function(){
            let paymentId = $(this).data('payment-id');
            $('#modal-delete-payment-btn').data('payment-id', paymentId);
            $('#delete-payment-modal').modal('show');
        });

        $('#modal-delete-payment-btn').on('click', function() {
            let paymentId = $(this).data('payment-id');
            let url = "{{ path('api_payment_delete') }}/" + paymentId;
            $.ajax({
                url: url,
                method: 'DELETE'
            }).done(function(response) {
                $(paymentListSelector).fadeIn();
                $(paymentListSelector).html(response);
            });
            $('#delete-payment-modal').modal('hide');
        });
    </script>
{% endblock %}